﻿--[[

Name: MusicStrem Tracks
Revision: $Revision: 23844 $
Date: $Date: 2007-01-07 03:01:22 -0500 (Sun, 07 Jan 2007) $
Author(s): benumbed (someone@somewhere.com)
Website: http://www.wowace.com/wiki/MusicStream
Documentation: http://www.wowace.com/wiki/MusicStream
SVN: http://svn.wowace.com/root/trunk/MusicStream
Description: A module to choose tracks by Artist/Album
Dependencies: Ace2, MusicStream

]]--

--- ========================================================= ---
--- Revision
--- ========================================================= ---

local Revision = tonumber(string.sub("$Revision: 23844 $", 12, -3))
if not Revision then
	Revision = "2.0"
end

--- ========================================================= ---
--- Add Locale
--- ========================================================= ---
local L = AceLibrary("AceLocale-2.2"):new("Tracks")

L:RegisterTranslations("enUS", function() return {
    ["Tracks"] = true,
    ["Play a Track"] = true,	

} end)

--- ========================================================= ---
--- Add Music Library
--- ========================================================= ---
local Music = AceLibrary("Music-2.0")

--- ========================================================= ---
--- Register New Module
--- ========================================================= ---

MusicStreamTracks = MusicStream:NewModule("Tracks")

--- ========================================================= ---
--- On Initialize
--- ========================================================= ---

function MusicStreamTracks:OnInitialize()
    self.db = MusicStream:AcquireDBNamespace("Tracks")
	
	MusicStreamTracks.defaultDB = {
    }
	
	MusicStream:RegisterDefaults("Tracks", "profile", opts or MusicStreamTracks.defaultDB or {})
    
	local bluecolor = "|cFF0099CC"
	local lbluecolor = "|cFF77BBFF"
	
	MusicStream.Options.args.TracksBlank = {
		type = 'header',
		order = 149,
    }
	
    MusicStream.Options.args.Tracks = {
        name = L["Tracks"],
        desc = L["Play a Track"],
		order = 150,
        type = "group",
        args = {
			header = {
				type = "header",
				name = bluecolor..L["Tracks"].."  |c88888888"..Revision,
				icon = "Interface\\Addons\\MusicStream\\icon.tga",
				iconHeight = 14,
				iconWidth = 14,
				order = 1
            },
			blank = {
       			type = "header",
				order = 2,
			},
        }
    }
	
	MusicStreamTracks:BuildMusic();
	
end

--- ========================================================= ---
--- Reset DB
--- ========================================================= ---

local function copyTable(to, from)
	setmetatable(to, nil)
	for k,v in pairs(from) do
		if type(k) == "table" then
			k = copyTable({}, k)
		end
		if type(v) == "table" then
			v = copyTable({}, v)
		end
		to[k] = v
	end
	setmetatable(to, from)
	return to
end

function MusicStreamTracks:ResetDB()
	copyTable(self.db.profile, MusicStreamTracks.defaultDB)
end

--- ========================================================= ---
--- Tracks
--- ========================================================= ---
function MusicStreamTracks:BuildMusic()

	for i, data in pairs(Music_Tracks) do
		MusicStream.Options.args.Tracks.args[data.artist] = {
			name = data.artist,
			desc = data.artist,
			order = 100,
			type = 'group',
			args = { },
		}
	end
	
	for i, data in pairs(Music_Tracks) do
		MusicStream.Options.args.Tracks.args[data.artist].args[data.album] = {
			name = data.album,
			desc = data.album,
			order = 100,
			type = 'group',
			args = { },
		}
	end
	
	for i, data in pairs(Music_Tracks) do
		MusicStream.Options.args.Tracks.args[data.artist].args[data.album].args[data.title] = {
			name = data.title,
			desc = data.title,
			order = data.track,
			type = 'execute',
			func = function() Track = data.track; MusicStream:Play(); end,
		}
	end
	
end